=== debian/changelog ===
halide (13.0.1-4) unstable; urgency=medium

  * Hopefully fix i386 build - add missing preprocessor check for SSE.
  * Hopefully fix riscv64 build - disable PGO/LTO.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Mon, 06 Dec 2021 23:34:00 +0300

halide (13.0.1-3) unstable; urgency=medium

  * Use LLVM LLD linker
  * Also build halide test apps
  * Perform 2-stage build (PGO)
  * Mark `libhalide13-doc` as `Multi-Arch: foreign`, as
    suggested by multiarch hinter

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Sat, 04 Dec 2021 13:20:48 +0300

halide (13.0.1-2) unstable; urgency=medium

  * No changes from the previous version, but a source-only upload this time.

 -- Roman Lebedev <lebedev.ri@gmail.com>  Thu, 25 Nov 2021 11:27:50 +0300

halide (13.0.1-1) unstable; urgency=medium

  * Update to newest upstream release

 -- Roman Lebedev <lebedev.ri@gmail.com>  Mon, 22 Nov 2021 12:39:22 +0300
